## collada-dom 2.3.2.3

=== CMakeLists.txt ===
cmake_minimum_required (VERSION 2.6.0)
project (collada-dom)
set( CMAKE_ALLOW_LOOSE_LOOP_CONSTRUCTS TRUE )

# Define here the needed parameters
set (COLLADA_DOM_VERSION_MAJOR 2)
set (COLLADA_DOM_VERSION_MINOR 3)
set (COLLADA_DOM_VERSION_PATCH 2)
set (COLLADA_DOM_VERSION ${COLLADA_DOM_VERSION_MAJOR}.${COLLADA_DOM_VERSION_MINOR}.${COLLADA_DOM_VERSION_PATCH})
set (COLLADA_DOM_SOVERSION ${COLLADA_DOM_VERSION_MAJOR}.${COLLADA_DOM_VERSION_MINOR})

message(STATUS "Compiling Collada DOM Version ${COLLADA_DOM_VERSION}")
message(STATUS "Using cmake version ${CMAKE_MAJOR_VERSION}.${CMAKE_MINOR_VERSION}" )

# http://www.cmake.org/cmake/help/cmake-2.6.html#policy:CMP0002
cmake_policy(SET CMP0002 NEW)
# http://www.cmake.org/cmake/help/cmake-2.6.html#policy:CMP0003
cmake_policy(SET CMP0003 NEW)

# Use, i.e. don't skip the full RPATH for the build tree
set(CMAKE_SKIP_BUILD_RPATH  FALSE)

# When building, don't use the install RPATH already
# (but later on when installing)
set(CMAKE_BUILD_WITH_INSTALL_RPATH FALSE)

# The RPATH to be used when installing
set(CMAKE_INSTALL_RPATH "${CMAKE_INSTALL_PREFIX}/lib${LIB_SUFFIX}")

# Add the automatically determined parts of the RPATH
# which point to directories outside the build tree to the install RPATH
set(CMAKE_INSTALL_RPATH_USE_LINK_PATH TRUE)

message(STATUS "installing to ${CMAKE_INSTALL_PREFIX}")

##############################################################################
# Custom CMake options
##############################################################################

option(OPT_COLLADA15 "Enable collada 1.5 compilation" ON)
option(OPT_COLLADA14 "Enable collada 1.4 compilation" ON)
option(OPT_COMPILE_VIEWER "Enable collada viewer compilation" OFF)
option(OPT_COMPILE_FX "Enable collada fx compilation" OFF)
option(OPT_COMPILE_RT "Enable collada rt compilation" OFF)
option(OPT_BUILD_PACKAGES "Set to ON to generate CPack configuration files and packaging targets" OFF)

if( OPT_COMPILE_VIEWER )
  message(WARNING "compiling collada viewer currently not supported")
endif()
if( OPT_COMPILE_FX )
  message(WARNING "compiling collada fx currently not supported")
endif()
if( OPT_COMPILE_RT )
  message(WARNING "compiling collada rt currently not supported")
endif()

set(PACKAGE_VERSION "0" CACHE STRING "the package-specific version used for uploading the sources")

set(CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake-modules")
set(COMPONENT_PREFIX libcollada)
string(TOUPPER ${COMPONENT_PREFIX} COMPONENT_PREFIX_UPPER)
set(CPACK_COMPONENTS_ALL ${COMPONENT_PREFIX}dom-dev)

if( MSVC )
  if( MSVC70 OR MSVC71 )
    set(MSVC_PREFIX "vc70")
  elseif( MSVC80 )
    set(MSVC_PREFIX "vc80")
  elseif( MSVC90 )
    set(MSVC_PREFIX "vc90")
  else()
    set(MSVC_PREFIX "vc100")
  endif()
  set(COLLADA_DOM_LIBRARY_SUFFIX "${COLLADA_DOM_SOVERSION}-${MSVC_PREFIX}-mt")
endif()

include(CheckIncludeFile)
include(CheckIncludeFileCXX)
include(CheckLibraryExists)
include(CheckFunctionExists)
include(CheckCXXSourceCompiles)
#include(CheckCXXSourceRuns)
#include(CheckCXXCompilerFlag)
include(CheckTypeSize)
find_package(PkgConfig)

if( CMAKE_COMPILER_IS_GNUCC OR CMAKE_COMPILER_IS_GNUCXX )
  add_definitions("-fno-strict-aliasing -Wall")
endif()

if( CMAKE_COMPILER_IS_GNUCC OR CMAKE_COMPILER_IS_GNUCXX )
  set(CMAKE_CXX_FLAGS_RELEASE "-O2")# -DNDEBUG -DBOOST_DISABLE_ASSERTS -D_SECURE_SCL=0") # this practically removes all checks making it a very dangerous options to play with
  set(CMAKE_CXX_FLAGS_RELWITHDEBINFO "-O2 -g")
  set(CMAKE_CXX_FLAGS_DEBUG "-g -D_DEBUG")
endif()

if( UNIX OR CMAKE_COMPILER_IS_GNUCC OR CMAKE_COMPILER_IS_GNUCXX )
  set(STDC_LIBRARY stdc++)
else()
  set(STDC_LIBRARY)
endif()

if( APPLE OR ${CMAKE_SYSTEM_NAME} MATCHES "Darwin")
  # apple doesn't have 64bit versions of file opening functions, so add them
  add_definitions("-Dfopen64=fopen -Dfseeko64=fseeko -Dfseek64=fseek -Dftell64=ftell -Dftello64=ftello")
endif()

set(COLLADA_DOM_INCLUDE_INSTALL_DIR "include/collada-dom")

set(COLLADA_DOM_INCLUDE_DIRS ${CMAKE_CURRENT_SOURCE_DIR}/dom/include)
set(COLLADA_DOM_LINK_DIRS "")

if( MSVC )
  # force multi-threaded DLL boost
  set(Boost_USE_MULTITHREAD ON)
  set(Boost_USE_STATIC_LIBS OFF)
  set(Boost_USE_STATIC_RUNTIME OFF)
  set(Boost_CFLAGS "-DBOOST_ALL_DYN_LINK -DBOOST_ALL_NO_LIB")
endif()
  
set(Boost_ADDITIONAL_VERSIONS "1.46" "1.45" "1.44" "1.43" "1.42" "1.41" "1.40" "1.39" "1.38" "1.37.0" "1.37" "1.35.0" "1.34.1" "1.34.0" "1.34" "1.33.1" "1.33.0" "1.33")

if( NOT $ENV{BOOST_INCLUDEDIR} STREQUAL "" )
  set(Boost_INCLUDE_DIR $ENV{BOOST_INCLUDEDIR})
endif()
if( NOT $ENV{BOOST_LIBRARYDIR} STREQUAL "" )
  set(Boost_LIBRARY_DIRS $ENV{BOOST_LIBRARYDIR})
endif()
find_package(Boost COMPONENTS filesystem system REQUIRED)

message(STATUS "found boost version: ${Boost_VERSION}")

if( Boost_FOUND )
  include_directories(${Boost_INCLUDE_DIRS})
  set(COLLADA_DOM_LINK_DIRS ${COLLADA_DOM_LINK_DIRS} ${Boost_LIBRARY_DIRS})
elseif(Boost_VERSION AND NOT "${Boost_VERSION}" STREQUAL "0")
  include_directories(${Boost_INCLUDE_DIRS})
  set(COLLADA_DOM_LINK_DIRS ${COLLADA_DOM_LINK_DIRS} ${Boost_LIBRARY_DIRS})
else()
  message(FATAL_ERROR "Could not find boost libraries!")
endif()

set(COLLADA_DOM_BOOST_INCLUDE_DIRS)
foreach(idir ${Boost_INCLUDE_DIRS})
  set(COLLADA_DOM_BOOST_INCLUDE_DIRS "${COLLADA_DOM_BOOST_INCLUDE_DIRS} -I${idir}")
endforeach()

set(COLLADA_DOM_BOOST_LIB_DIRS)
foreach(ldir ${Boost_LIBRARY_DIRS})
  set(COLLADA_DOM_BOOST_LIB_DIRS "${COLLADA_DOM_BOOST_LIB_DIRS} -L${ldir}")
endforeach()

if(CMAKE_COMPILER_IS_GNUCC OR CMAKE_COMPILER_IS_GNUCXX)
  set(EXTRA_COMPILE_FLAGS "-fPIC")
else()
  set(EXTRA_COMPILE_FLAGS "")
endif()

find_package(ZLIB)
if( NOT ZLIB_FOUND )
  message(STATUS "compiling zlib from souces and linking statically")
  # compile from sources
  add_subdirectory(dom/external-libs/zlib-1.2.5)
  set(ZLIB_FOUND 1)
  set(ZLIB_LIBRARIES zlib)
  set(ZLIB_INCLUDE_DIR ${CMAKE_CURRENT_SOURCE_DIR}/dom/external-libs/zlib-1.2.5)
endif()

find_package(LibXml2)
if( LIBXML2_FOUND )
  include_directories(${LIBXML2_INCLUDE_DIR})
  add_definitions(${LIBXML2_DEFINITIONS} -DDOM_INCLUDE_LIBXML)
  message(STATUS "libxml2 found")
else()
  if( MSVC )
    set(LIBXML2_LIBRARY_DIRS "${CMAKE_CURRENT_SOURCE_DIR}/dom/external-libs/libxml2-new/lib")
    set(LIBXML2_LIBRARIES "${LIBXML2_LIBRARY_DIRS}/libxml2-${MSVC_PREFIX}-mt.lib")
    set(LIBXML2_INCLUDE_DIR ${CMAKE_CURRENT_SOURCE_DIR}/dom/external-libs/libxml2-new/include)
    set(LIBXML2_DEFINITIONS)
    set(LIBXML2_FOUND 1)
    include_directories(${LIBXML2_INCLUDE_DIR})
    add_definitions(-DDOM_INCLUDE_LIBXML)
    # have to install the DLLs
    install(DIRECTORY "${LIBXML2_LIBRARY_DIRS}/" DESTINATION lib${LIB_SUFFIX} FILES_MATCHING PATTERN "*-${MSVC_PREFIX}-*.dll")
  else()
    message(FATAL_ERROR "Could not find libxml2")
  endif()
endif()

pkg_check_modules(minizip minizip)
if(minizip_FOUND)
  set(MINIZIP_INCLUDE_DIR ${minizip_INCLUDE_DIRS})
else()
  message(STATUS "compiling minizip from sources and linking statically")
  add_subdirectory(dom/external-libs/minizip-1.1)
  set(MINIZIP_INCLUDE_DIR ${CMAKE_CURRENT_SOURCE_DIR}/dom/external-libs/minizip-1.1 ${ZLIB_INCLUDE_DIR})
endif()

pkg_check_modules(libpcrecpp libpcrecpp)
if( libpcrecpp_FOUND )
  set(CMAKE_REQUIRED_INCLUDES ${libpcrecpp_INCLUDE_DIRS})
  check_include_file_cxx(pcrecpp.h HAVE_PCRECPP_H)
  set(CMAKE_REQUIRED_INCLUDES)
  if( NOT HAVE_PCRECPP_H )
    set(libpcrecpp_FOUND 0)
  endif()
endif()

if( NOT libpcrecpp_FOUND )
  message(STATUS "System pcre not found, using local from sources")
  # include the local pcre
  add_subdirectory(dom/external-libs/pcre-8.02)
  set(libpcrecpp_INCLUDE_DIRS ${CMAKE_CURRENT_SOURCE_DIR}/dom/external-libs/pcre-8.02)
  set(libpcrecpp_LIBRARY_DIRS)
  set(libpcrecpp_LIBRARIES pcrecpp_local)
  set(libpcrecpp_CFLAGS_OTHERS "-DPCRE_STATIC")
  set(libpcrecpp_LDFLAGS_OTHERS)
endif()

# declare minizip/zlib before libxml2! (for some reason the precompiled libxml2 libraries have zlib.h/zconf.h)
include_directories(BEFORE ${MINIZIP_INCLUDE_DIR})
include_directories(BEFORE ${libpcrecpp_INCLUDE_DIRS})

set(COLLADA_DOM_LINK_DIRS ${COLLADA_DOM_LINK_DIRS} ${libpcrecpp_LIBRARY_DIRS})
link_directories(${COLLADA_DOM_LINK_DIRS})

add_subdirectory(dom)

if( OPT_COLLADA15 )
  if(UNIX)
    configure_file("${CMAKE_CURRENT_SOURCE_DIR}/collada15dom.pc.in" "${CMAKE_CURRENT_BINARY_DIR}/collada15dom.pc" @ONLY IMMEDIATE)
    install(FILES ${CMAKE_CURRENT_BINARY_DIR}/collada15dom.pc DESTINATION lib${LIB_SUFFIX}/pkgconfig COMPONENT ${COMPONENT_PREFIX}15dom-dev)
  endif()
  set(CPACK_COMPONENTS_ALL ${CPACK_COMPONENTS_ALL} ${COMPONENT_PREFIX}15dom ${COMPONENT_PREFIX}15dom-dev)
  set(CPACK_COMPONENT_${COMPONENT_PREFIX_UPPER}15DOM-DEV_DEPENDS ${COMPONENT_PREFIX}dom-dev ${COMPONENT_PREFIX}15dom)
endif()

if( OPT_COLLADA14 )
  if(UNIX)
    configure_file("${CMAKE_CURRENT_SOURCE_DIR}/collada14dom.pc.in" "${CMAKE_CURRENT_BINARY_DIR}/collada14dom.pc" @ONLY IMMEDIATE)
    install(FILES ${CMAKE_CURRENT_BINARY_DIR}/collada14dom.pc DESTINATION lib${LIB_SUFFIX}/pkgconfig COMPONENT ${COMPONENT_PREFIX}14dom-dev)
  endif()
  set(CPACK_COMPONENTS_ALL ${CPACK_COMPONENTS_ALL} ${COMPONENT_PREFIX}14dom ${COMPONENT_PREFIX}14dom-dev)
  set(CPACK_COMPONENT_${COMPONENT_PREFIX_UPPER}14DOM-DEV_DEPENDS ${COMPONENT_PREFIX}dom-dev ${COMPONENT_PREFIX}14dom)
endif()

configure_file("${CMAKE_CURRENT_SOURCE_DIR}/collada_dom-config.cmake.in" "${CMAKE_CURRENT_BINARY_DIR}/collada_dom-config.cmake" @ONLY IMMEDIATE)
configure_file("${CMAKE_CURRENT_SOURCE_DIR}/collada_dom-config-version.cmake.in" "${CMAKE_CURRENT_BINARY_DIR}/collada_dom-config-version.cmake" @ONLY IMMEDIATE)
install(FILES "${CMAKE_CURRENT_BINARY_DIR}/collada_dom-config.cmake" "${CMAKE_CURRENT_BINARY_DIR}/collada_dom-config-version.cmake" DESTINATION "lib${LIB_SUFFIX}/cmake/collada_dom" COMPONENT ${COMPONENT_PREFIX}dom-dev)

# add make uninstall capability
configure_file("${CMAKE_CURRENT_SOURCE_DIR}/cmake-modules/cmake_uninstall.cmake.in" "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake" IMMEDIATE @ONLY)

add_custom_target(uninstall "${CMAKE_COMMAND}" -P "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake")

if(CMAKE_CPACK_COMMAND AND UNIX AND OPT_BUILD_PACKAGES)
  # Packing information
  set(CPACK_PACKAGE_NAME collada-dom${COLLADA_DOM_VERSION_MAJOR}.${COLLADA_DOM_VERSION_MINOR})
  set(CPACK_PACKAGE_CONTACT "" CACHE STRING "Package maintainer and PGP signer.")
  set(CPACK_PACKAGE_VENDOR "http://sourceforge.net/projects/collada-dom")
  set(CPACK_PACKAGE_DISPLAY_NAME "collada-dom ${COLLADA_DOM_VERSION}")
  set(CPACK_PACKAGE_DESCRIPTION_SUMMARY " - COLLADA")
  set(CPACK_PACKAGE_VERSION ${COLLADA_DOM_VERSION}.${PACKAGE_VERSION})
  set(CPACK_PACKAGE_VERSION_MAJOR ${COLLADA_DOM_VERSION_MAJOR})
  set(CPACK_PACKAGE_VERSION_MINOR ${COLLADA_DOM_VERSION_MINOR})
  set(CPACK_PACKAGE_VERSION_PATCH ${COLLADA_DOM_VERSION_PATCH})
  set(CPACK_PACKAGE_INSTALL_DIRECTORY "collada-dom${COLLADA_DOM_VERSION_MAJOR}.${COLLADA_DOM_VERSION_MINOR}")
  set(CPACK_PACKAGE_DESCRIPTION_FILE ${CMAKE_CURRENT_SOURCE_DIR}/description)
  set(CPACK_RESOURCE_FILE_LICENSE ${CMAKE_CURRENT_SOURCE_DIR}/dom/license.txt)

  set(CPACK_COMPONENT_${COMPONENT_PREFIX_UPPER}DOM-DEV_DISPLAY_NAME "common headers and installs")
  
  set(CPACK_DEBIAN_BUILD_DEPENDS debhelper cmake libxml2-dev libboost-dev zlib1g-dev libboost-filesystem-dev libboost-system-dev libpcre3-dev pkg-config)

  # debian
  set(CPACK_DEBIAN_PACKAGE_PRIORITY optional)
  set(CPACK_DEBIAN_PACKAGE_SECTION libs)
  set(CPACK_DEBIAN_PACKAGE_DEPENDS ${CPACK_COMPONENTS_ALL})
  set(CPACK_DEBIAN_PACKAGE_SUGGESTS)
  set(CPACK_DEBIAN_PACKAGE_NAME collada-dom)
  set(CPACK_DEBIAN_PACKAGE_REMOVE_SOURCE_FILES viewer fx rt Makefile.linux Makefile dom/codeGen dom/Makefile dom/external-libs/boost dom/external-libs/libxml2 dom/external-libs/minizip dom/external-libs/pcre dom/external-libs/pcre-8.02 dom/external-libs/zlib-1.2.5 dom/test dom/release dom/projects dom/make)
  set(CPACK_DEBIAN_PACKAGE_SOURCE_COPY svn export --force)

=== dom/CMakeLists.txt ===
include_directories(${CMAKE_CURRENT_SOURCE_DIR}/include)
set(COLLADA_LIBS minizip ${libpcrecpp_LIBRARIES} ${ZLIB_LIBRARIES} ${Boost_FILESYSTEM_LIBRARY} ${Boost_SYSTEM_LIBRARY})

set(COLLADA14_INCLUDE_DIR ${CMAKE_CURRENT_SOURCE_DIR}/include/1.4)
set(COLLADA15_INCLUDE_DIR ${CMAKE_CURRENT_SOURCE_DIR}/include/1.5)
file(GLOB dae_files ${CMAKE_CURRENT_SOURCE_DIR}/src/dae/*.cpp)
if( LIBXML2_FOUND )
  file(GLOB libxmlplugin_files ${CMAKE_CURRENT_SOURCE_DIR}/src/modules/LIBXMLPlugin/*.cpp)
  set(COLLADA_LIBS ${COLLADA_LIBS} ${LIBXML2_LIBRARIES})
else()
  set(libxmlplugin_files)
endif()
file(GLOB stddatabase_files ${CMAKE_CURRENT_SOURCE_DIR}/src/modules/STLDatabase/*.cpp)
file(GLOB stderrplugin_files ${CMAKE_CURRENT_SOURCE_DIR}/src/modules/stdErrPlugin/*.cpp)

set(COLLADA_BASE_SOURCES ${dae_files} ${libxmlplugin_files} ${stddatabase_files} ${stderrplugin_files})
set(COLLADA_COMPILE_FLAGS "${libpcrecpp_CFLAGS_OTHERS} ${EXTRA_COMPILE_FLAGS} ${Boost_CFLAGS}")
# create dynamic libraries
set(COLLADA_COMPILE_FLAGS "${COLLADA_COMPILE_FLAGS} -DDOM_DYNAMIC -DDOM_EXPORT")

if( OPT_COLLADA15 )
  add_subdirectory(src/1.5)
  install(DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/include/1.5 DESTINATION ${COLLADA_DOM_INCLUDE_INSTALL_DIR} COMPONENT ${COMPONENT_PREFIX}15dom-dev  PATTERN ".svn" EXCLUDE PATTERN ".~" EXCLUDE)
endif()
if( OPT_COLLADA14 )
  add_subdirectory(src/1.4)
  install(DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/include/1.4 DESTINATION ${COLLADA_DOM_INCLUDE_INSTALL_DIR} COMPONENT ${COMPONENT_PREFIX}14dom-dev  PATTERN ".svn" EXCLUDE PATTERN ".~" EXCLUDE)
endif()

install(DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/include/dae DESTINATION ${COLLADA_DOM_INCLUDE_INSTALL_DIR} COMPONENT ${COMPONENT_PREFIX}dom-dev PATTERN ".svn" EXCLUDE PATTERN ".~" EXCLUDE)
install(DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/include/modules DESTINATION ${COLLADA_DOM_INCLUDE_INSTALL_DIR} COMPONENT ${COMPONENT_PREFIX}dom-dev  PATTERN ".svn" EXCLUDE PATTERN ".~" EXCLUDE)
install(FILES ${CMAKE_CURRENT_SOURCE_DIR}/include/dae.h ${CMAKE_CURRENT_SOURCE_DIR}/include/dom.h DESTINATION ${COLLADA_DOM_INCLUDE_INSTALL_DIR} COMPONENT ${COMPONENT_PREFIX}dom-dev )

=== dom/src/1.4/CMakeLists.txt ===
file(GLOB dom_files ${CMAKE_CURRENT_SOURCE_DIR}/dom/*.cpp)
include_directories(${COLLADA14_INCLUDE_DIR})
add_library(collada14dom SHARED ${COLLADA_BASE_SOURCES} ${dom_files})
target_link_libraries(collada14dom ${COLLADA_LIBS})
set_target_properties(collada14dom PROPERTIES
  COMPILE_FLAGS "${COLLADA_COMPILE_FLAGS}"
  LINK_FLAGS "${libpcrecpp_LDFLAGS_OTHERS}"
  OUTPUT_NAME collada14dom${COLLADA_DOM_LIBRARY_SUFFIX}
  CLEAN_DIRECT_OUTPUT 1
  SOVERSION ${COLLADA_DOM_SOVERSION}
  VERSION ${COLLADA_DOM_VERSION})
install(TARGETS collada14dom DESTINATION lib${LIB_SUFFIX} COMPONENT ${COMPONENT_PREFIX}14dom-dev )

=== dom/src/1.5/CMakeLists.txt ===
file(GLOB dom_files ${CMAKE_CURRENT_SOURCE_DIR}/dom/*.cpp)
include_directories(${COLLADA15_INCLUDE_DIR})
add_library(collada15dom SHARED ${COLLADA_BASE_SOURCES} ${dom_files})
target_link_libraries(collada15dom ${COLLADA_LIBS})
set_target_properties(collada15dom PROPERTIES
  COMPILE_FLAGS "${COLLADA_COMPILE_FLAGS}"
  LINK_FLAGS "${libpcrecpp_LDFLAGS_OTHERS}"
  OUTPUT_NAME collada15dom${COLLADA_DOM_LIBRARY_SUFFIX}
  CLEAN_DIRECT_OUTPUT 1
  SOVERSION ${COLLADA_DOM_SOVERSION}
  VERSION ${COLLADA_DOM_VERSION})
install(TARGETS collada15dom DESTINATION lib${LIB_SUFFIX} COMPONENT ${COMPONENT_PREFIX}15dom-dev )

=== debian/changelog ===
collada-dom (2.3.2.3-ubuntu1~natty1) natty; urgency=low

  * Package built with CMake

 -- OpenRAVE Testing (Testing and Releasing of OpenRAVE Packages) <openrave.testing@gmail.com>  Wed, 19 Oct 2011 16:20:12 +0900

=== debian/control ===
Source: collada-dom
Section: libs
Priority: optional
DM-Upload-Allowed: yes
Maintainer: OpenRAVE Testing (Testing and Releasing of OpenRAVE Packages) <openrave.testing@gmail.com>
Build-Depends: debhelper, cmake, libxml2-dev, libboost-dev, zlib1g-dev, libboost-filesystem-dev, libboost-system-dev, libpcre3-dev, pkg-config, 
Standards-Version: 3.8.4
Homepage: http://sourceforge.net/projects/collada-dom

Package: collada-dom
Architecture: any
Suggests: 
Depends: libcolladadom-dev, libcollada15dom, libcollada15dom-dev, libcollada14dom, libcollada14dom-dev, 
Description: collada-dom 2.3.2  - COLLADA
 The COLLADA Document Object Model (DOM) is an application programming interface (API) that provides a C++ object representation of a COLLADA XML instance document. Contact a project admin to become a developer!

Package: libcolladadom-dev
Architecture: any
Depends: ${shlibs:Depends}
Description: collada-dom 2.3.2 common headers and installs
 The COLLADA Document Object Model (DOM) is an application programming interface (API) that provides a C++ object representation of a COLLADA XML instance document. Contact a project admin to become a developer!
 .
 

Package: libcollada15dom
Architecture: any
Depends: ${shlibs:Depends}
Description: collada-dom 2.3.2 
 The COLLADA Document Object Model (DOM) is an application programming interface (API) that provides a C++ object representation of a COLLADA XML instance document. Contact a project admin to become a developer!
 .
 

Package: libcollada15dom-dev
Architecture: any
Depends: ${shlibs:Depends}, libcolladadom-dev, libcollada15dom
Description: collada-dom 2.3.2 
 The COLLADA Document Object Model (DOM) is an application programming interface (API) that provides a C++ object representation of a COLLADA XML instance document. Contact a project admin to become a developer!
 .
 

Package: libcollada14dom
Architecture: any
Depends: ${shlibs:Depends}
Description: collada-dom 2.3.2 
 The COLLADA Document Object Model (DOM) is an application programming interface (API) that provides a C++ object representation of a COLLADA XML instance document. Contact a project admin to become a developer!
 .
 

Package: libcollada14dom-dev
Architecture: any
Depends: ${shlibs:Depends}, libcolladadom-dev, libcollada14dom
Description: collada-dom 2.3.2 
 The COLLADA Document Object Model (DOM) is an application programming interface (API) that provides a C++ object representation of a COLLADA XML instance document. Contact a project admin to become a developer!
 .

=== debian/rules ===
#!/usr/bin/make -f

BUILDDIR = build_dir

build:
	mkdir $(BUILDDIR)
	cd $(BUILDDIR); cmake -DCMAKE_BUILD_TYPE=Release -DBASH_COMPLETION_DIR=../etc/bash_completion.d -DCMAKE_INSTALL_PREFIX=/usr ..
	$(MAKE) -C $(BUILDDIR) preinstall
	touch build

binary: binary-indep binary-arch

binary-indep: build

binary-arch: build
	cd $(BUILDDIR); cmake -DCOMPONENT=Unspecified -DCMAKE_INSTALL_PREFIX=../debian/tmp/usr -P cmake_install.cmake
	mkdir -p debian/tmp/DEBIAN
	dpkg-gensymbols -pcollada-dom
	cd $(BUILDDIR); cmake -DCOMPONENT=libcolladadom-dev -DCMAKE_INSTALL_PREFIX=../debian/libcolladadom-dev/usr -P cmake_install.cmake
	mkdir -p debian/libcolladadom-dev/DEBIAN
	dpkg-gensymbols -plibcolladadom-dev -Pdebian/libcolladadom-dev
	cd $(BUILDDIR); cmake -DCOMPONENT=libcollada15dom -DCMAKE_INSTALL_PREFIX=../debian/libcollada15dom/usr -P cmake_install.cmake
	mkdir -p debian/libcollada15dom/DEBIAN
	dpkg-gensymbols -plibcollada15dom -Pdebian/libcollada15dom
	cd $(BUILDDIR); cmake -DCOMPONENT=libcollada15dom-dev -DCMAKE_INSTALL_PREFIX=../debian/libcollada15dom-dev/usr -P cmake_install.cmake
	mkdir -p debian/libcollada15dom-dev/DEBIAN
	dpkg-gensymbols -plibcollada15dom-dev -Pdebian/libcollada15dom-dev
	cd $(BUILDDIR); cmake -DCOMPONENT=libcollada14dom -DCMAKE_INSTALL_PREFIX=../debian/libcollada14dom/usr -P cmake_install.cmake
	mkdir -p debian/libcollada14dom/DEBIAN
	dpkg-gensymbols -plibcollada14dom -Pdebian/libcollada14dom
	cd $(BUILDDIR); cmake -DCOMPONENT=libcollada14dom-dev -DCMAKE_INSTALL_PREFIX=../debian/libcollada14dom-dev/usr -P cmake_install.cmake
	mkdir -p debian/libcollada14dom-dev/DEBIAN
	dpkg-gensymbols -plibcollada14dom-dev -Pdebian/libcollada14dom-dev
	dh_shlibdeps
	dh_strip
	dpkg-gencontrol -pcollada-dom
	dpkg --build debian/tmp ..
	dpkg-gencontrol -plibcolladadom-dev -Pdebian/libcolladadom-dev -Tdebian/libcolladadom-dev.substvars
	dpkg --build debian/libcolladadom-dev ..
	dpkg-gencontrol -plibcollada15dom -Pdebian/libcollada15dom -Tdebian/libcollada15dom.substvars
	dpkg --build debian/libcollada15dom ..
	dpkg-gencontrol -plibcollada15dom-dev -Pdebian/libcollada15dom-dev -Tdebian/libcollada15dom-dev.substvars
	dpkg --build debian/libcollada15dom-dev ..
	dpkg-gencontrol -plibcollada14dom -Pdebian/libcollada14dom -Tdebian/libcollada14dom.substvars
	dpkg --build debian/libcollada14dom ..
	dpkg-gencontrol -plibcollada14dom-dev -Pdebian/libcollada14dom-dev -Tdebian/libcollada14dom-dev.substvars
	dpkg --build debian/libcollada14dom-dev ..

clean:
	rm -f build
	rm -rf $(BUILDDIR)

.PHONY: binary binary-arch binary-indep clean

## collada-dom 2.4.3+ds3

=== CMakeLists.txt ===
--- 
+++ 
@@ -4,8 +4,8 @@
 
 # Define here the needed parameters
 set (COLLADA_DOM_VERSION_MAJOR 2)
-set (COLLADA_DOM_VERSION_MINOR 3)
-set (COLLADA_DOM_VERSION_PATCH 2)
+set (COLLADA_DOM_VERSION_MINOR 4)
+set (COLLADA_DOM_VERSION_PATCH 3)
 set (COLLADA_DOM_VERSION ${COLLADA_DOM_VERSION_MAJOR}.${COLLADA_DOM_VERSION_MINOR}.${COLLADA_DOM_VERSION_PATCH})
 set (COLLADA_DOM_SOVERSION ${COLLADA_DOM_VERSION_MAJOR}.${COLLADA_DOM_VERSION_MINOR})
 
@@ -42,7 +42,31 @@
 option(OPT_COMPILE_VIEWER "Enable collada viewer compilation" OFF)
 option(OPT_COMPILE_FX "Enable collada fx compilation" OFF)
 option(OPT_COMPILE_RT "Enable collada rt compilation" OFF)
+option(OPT_COMPILE_TESTS "Compile collada tests" OFF)
 option(OPT_BUILD_PACKAGES "Set to ON to generate CPack configuration files and packaging targets" OFF)
+option(OPT_BUILD_PACKAGE_DEFAULT "Set to ON to generate a default openrave package that creates symlinks" ON)
+option(OPT_DOUBLE_PRECISION "Use double precision for everything (daeFloat included)" ON)
+
+set(COLLADA_DOM_EXTERNAL_FLAGS)
+if( OPT_COLLADA14 )
+  set(COLLADA_DOM_EXTERNAL_FLAGS "${COLLADA_DOM_EXTERNAL_FLAGS} -DCOLLADA_DOM_SUPPORT141")
+endif()
+if( OPT_COLLADA15 )
+  set(COLLADA_DOM_EXTERNAL_FLAGS "${COLLADA_DOM_EXTERNAL_FLAGS} -DCOLLADA_DOM_SUPPORT150")
+endif()
+
+set(CPACK_DEBIAN_PACKAGE_NAME collada-dom${COLLADA_DOM_SOVERSION})
+if(OPT_DOUBLE_PRECISION)
+  set(COLLADA_PRECISION "dp")
+  set(CPACK_DEBIAN_PACKAGE_NAME "${CPACK_DEBIAN_PACKAGE_NAME}-dp")
+  set(COLLADA_DOM_EXTERNAL_FLAGS "${COLLADA_DOM_EXTERNAL_FLAGS} -DCOLLADA_DOM_DAEFLOAT_IS64") # daeFloat is 64 bit
+  message(STATUS "compiling with double float precision")
+else()
+  set(COLLADA_PRECISION "sp")
+  set(CPACK_DEBIAN_PACKAGE_NAME "${CPACK_DEBIAN_PACKAGE_NAME}-sp")
+  message(STATUS "compiling with single float precision")
+endif()
+
 
 if( OPT_COMPILE_VIEWER )
   message(WARNING "compiling collada viewer currently not supported")
@@ -57,9 +81,9 @@
 set(PACKAGE_VERSION "0" CACHE STRING "the package-specific version used for uploading the sources")
 
 set(CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake-modules")
-set(COMPONENT_PREFIX libcollada)
+set(COMPONENT_PREFIX "${CPACK_DEBIAN_PACKAGE_NAME}")
 string(TOUPPER ${COMPONENT_PREFIX} COMPONENT_PREFIX_UPPER)
-set(CPACK_COMPONENTS_ALL ${COMPONENT_PREFIX}dom-dev)
+set(CPACK_COMPONENTS_ALL ${COMPONENT_PREFIX}-base ${COMPONENT_PREFIX}-dev)
 
 if( MSVC )
   if( MSVC70 OR MSVC71 )
@@ -71,7 +95,9 @@
   else()
     set(MSVC_PREFIX "vc100")
   endif()
-  set(COLLADA_DOM_LIBRARY_SUFFIX "${COLLADA_DOM_SOVERSION}-${MSVC_PREFIX}-mt")
+  set(COLLADA_DOM_LIBRARY_SUFFIX "${COLLADA_DOM_SOVERSION}-${COLLADA_PRECISION}-${MSVC_PREFIX}-mt")
+else()
+  set(COLLADA_DOM_LIBRARY_SUFFIX "${COLLADA_DOM_SOVERSION}-${COLLADA_PRECISION}")
 endif()
 
 include(CheckIncludeFile)
@@ -102,10 +128,14 @@
 
 if( APPLE OR ${CMAKE_SYSTEM_NAME} MATCHES "Darwin")
   # apple doesn't have 64bit versions of file opening functions, so add them
-  add_definitions("-Dfopen64=fopen -Dfseeko64=fseeko -Dfseek64=fseek -Dftell64=ftell -Dftello64=ftello")
-endif()
-
-set(COLLADA_DOM_INCLUDE_INSTALL_DIR "include/collada-dom")
+  add_definitions("-Dfopen64=fopen")
+  add_definitions("-Dfseeko64=fseeko")
+  add_definitions("-Dfseek64=fseek")
+  add_definitions("-Dftell64=ftell")
+  add_definitions("-Dftello64=ftello")
+endif()
+
+set(COLLADA_DOM_INCLUDE_INSTALL_DIR "include/collada-dom${COLLADA_DOM_SOVERSION}")
 
 set(COLLADA_DOM_INCLUDE_DIRS ${CMAKE_CURRENT_SOURCE_DIR}/dom/include)
 set(COLLADA_DOM_LINK_DIRS "")
@@ -151,9 +181,9 @@
 endforeach()
 
 if(CMAKE_COMPILER_IS_GNUCC OR CMAKE_COMPILER_IS_GNUCXX)
-  set(EXTRA_COMPILE_FLAGS "-fPIC")
-else()
-  set(EXTRA_COMPILE_FLAGS "")
+  set(EXTRA_COMPILE_FLAGS "${COLLADA_DOM_EXTERNAL_FLAGS} -DCOLLADA_DOM_NAMESPACE -fPIC")
+else()
+  set(EXTRA_COMPILE_FLAGS "${COLLADA_DOM_EXTERNAL_FLAGS} -DCOLLADA_DOM_NAMESPACE")
 endif()
 
 find_package(ZLIB)
@@ -226,27 +256,28 @@
 
 add_subdirectory(dom)
 
+if(UNIX)
+  configure_file("${CMAKE_CURRENT_SOURCE_DIR}/collada-dom.pc.in" "${CMAKE_CURRENT_BINARY_DIR}/collada-dom.pc" @ONLY IMMEDIATE)
+  install(FILES ${CMAKE_CURRENT_BINARY_DIR}/collada-dom.pc DESTINATION lib${LIB_SUFFIX}/pkgconfig COMPONENT ${COMPONENT_PREFIX}-dev)
+endif()
+
 if( OPT_COLLADA15 )
   if(UNIX)
-    configure_file("${CMAKE_CURRENT_SOURCE_DIR}/collada15dom.pc.in" "${CMAKE_CURRENT_BINARY_DIR}/collada15dom.pc" @ONLY IMMEDIATE)
-    install(FILES ${CMAKE_CURRENT_BINARY_DIR}/collada15dom.pc DESTINATION lib${LIB_SUFFIX}/pkgconfig COMPONENT ${COMPONENT_PREFIX}15dom-dev)
-  endif()
-  set(CPACK_COMPONENTS_ALL ${CPACK_COMPONENTS_ALL} ${COMPONENT_PREFIX}15dom ${COMPONENT_PREFIX}15dom-dev)
-  set(CPACK_COMPONENT_${COMPONENT_PREFIX_UPPER}15DOM-DEV_DEPENDS ${COMPONENT_PREFIX}dom-dev ${COMPONENT_PREFIX}15dom)
+    configure_file("${CMAKE_CURRENT_SOURCE_DIR}/collada-dom-150.pc.in" "${CMAKE_CURRENT_BINARY_DIR}/collada-dom-150.pc" @ONLY IMMEDIATE)
+    install(FILES ${CMAKE_CURRENT_BINARY_DIR}/collada-dom-150.pc DESTINATION lib${LIB_SUFFIX}/pkgconfig COMPONENT ${COMPONENT_PREFIX}-dev)
+  endif()
 endif()
 
 if( OPT_COLLADA14 )
   if(UNIX)
-    configure_file("${CMAKE_CURRENT_SOURCE_DIR}/collada14dom.pc.in" "${CMAKE_CURRENT_BINARY_DIR}/collada14dom.pc" @ONLY IMMEDIATE)
-    install(FILES ${CMAKE_CURRENT_BINARY_DIR}/collada14dom.pc DESTINATION lib${LIB_SUFFIX}/pkgconfig COMPONENT ${COMPONENT_PREFIX}14dom-dev)
-  endif()
-  set(CPACK_COMPONENTS_ALL ${CPACK_COMPONENTS_ALL} ${COMPONENT_PREFIX}14dom ${COMPONENT_PREFIX}14dom-dev)
-  set(CPACK_COMPONENT_${COMPONENT_PREFIX_UPPER}14DOM-DEV_DEPENDS ${COMPONENT_PREFIX}dom-dev ${COMPONENT_PREFIX}14dom)
+    configure_file("${CMAKE_CURRENT_SOURCE_DIR}/collada-dom-141.pc.in" "${CMAKE_CURRENT_BINARY_DIR}/collada-dom-141.pc" @ONLY IMMEDIATE)
+    install(FILES ${CMAKE_CURRENT_BINARY_DIR}/collada-dom-141.pc DESTINATION lib${LIB_SUFFIX}/pkgconfig COMPONENT ${COMPONENT_PREFIX}-dev)
+  endif()
 endif()
 
 configure_file("${CMAKE_CURRENT_SOURCE_DIR}/collada_dom-config.cmake.in" "${CMAKE_CURRENT_BINARY_DIR}/collada_dom-config.cmake" @ONLY IMMEDIATE)
 configure_file("${CMAKE_CURRENT_SOURCE_DIR}/collada_dom-config-version.cmake.in" "${CMAKE_CURRENT_BINARY_DIR}/collada_dom-config-version.cmake" @ONLY IMMEDIATE)
-install(FILES "${CMAKE_CURRENT_BINARY_DIR}/collada_dom-config.cmake" "${CMAKE_CURRENT_BINARY_DIR}/collada_dom-config-version.cmake" DESTINATION "lib${LIB_SUFFIX}/cmake/collada_dom" COMPONENT ${COMPONENT_PREFIX}dom-dev)
+install(FILES "${CMAKE_CURRENT_BINARY_DIR}/collada_dom-config.cmake" "${CMAKE_CURRENT_BINARY_DIR}/collada_dom-config-version.cmake" DESTINATION "lib${LIB_SUFFIX}/cmake/collada_dom-${COLLADA_DOM_SOVERSION}" COMPONENT ${COMPONENT_PREFIX}-dev)
 
 # add make uninstall capability
 configure_file("${CMAKE_CURRENT_SOURCE_DIR}/cmake-modules/cmake_uninstall.cmake.in" "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake" IMMEDIATE @ONLY)
@@ -255,28 +286,11 @@
 
 if(CMAKE_CPACK_COMMAND AND UNIX AND OPT_BUILD_PACKAGES)
   # Packing information
-  set(CPACK_PACKAGE_NAME collada-dom${COLLADA_DOM_VERSION_MAJOR}.${COLLADA_DOM_VERSION_MINOR})
+  set(CPACK_PACKAGE_NAME collada-dom${COLLADA_DOM_SOVERSION})
   set(CPACK_PACKAGE_CONTACT "" CACHE STRING "Package maintainer and PGP signer.")
   set(CPACK_PACKAGE_VENDOR "http://sourceforge.net/projects/collada-dom")
   set(CPACK_PACKAGE_DISPLAY_NAME "collada-dom ${COLLADA_DOM_VERSION}")
   set(CPACK_PACKAGE_DESCRIPTION_SUMMARY " - COLLADA")
-  set(CPACK_PACKAGE_VERSION ${COLLADA_DOM_VERSION}.${PACKAGE_VERSION})
-  set(CPACK_PACKAGE_VERSION_MAJOR ${COLLADA_DOM_VERSION_MAJOR})
-  set(CPACK_PACKAGE_VERSION_MINOR ${COLLADA_DOM_VERSION_MINOR})
-  set(CPACK_PACKAGE_VERSION_PATCH ${COLLADA_DOM_VERSION_PATCH})
-  set(CPACK_PACKAGE_INSTALL_DIRECTORY "collada-dom${COLLADA_DOM_VERSION_MAJOR}.${COLLADA_DOM_VERSION_MINOR}")
-  set(CPACK_PACKAGE_DESCRIPTION_FILE ${CMAKE_CURRENT_SOURCE_DIR}/description)
-  set(CPACK_RESOURCE_FILE_LICENSE ${CMAKE_CURRENT_SOURCE_DIR}/dom/license.txt)
-
-  set(CPACK_COMPONENT_${COMPONENT_PREFIX_UPPER}DOM-DEV_DISPLAY_NAME "common headers and installs")
-  
-  set(CPACK_DEBIAN_BUILD_DEPENDS debhelper cmake libxml2-dev libboost-dev zlib1g-dev libboost-filesystem-dev libboost-system-dev libpcre3-dev pkg-config)
-
-  # debian
-  set(CPACK_DEBIAN_PACKAGE_PRIORITY optional)
-  set(CPACK_DEBIAN_PACKAGE_SECTION libs)
-  set(CPACK_DEBIAN_PACKAGE_DEPENDS ${CPACK_COMPONENTS_ALL})
-  set(CPACK_DEBIAN_PACKAGE_SUGGESTS)
-  set(CPACK_DEBIAN_PACKAGE_NAME collada-dom)
-  set(CPACK_DEBIAN_PACKAGE_REMOVE_SOURCE_FILES viewer fx rt Makefile.linux Makefile dom/codeGen dom/Makefile dom/external-libs/boost dom/external-libs/libxml2 dom/external-libs/minizip dom/external-libs/pcre dom/external-libs/pcre-8.02 dom/external-libs/zlib-1.2.5 dom/test dom/release dom/projects dom/make)
-  set(CPACK_DEBIAN_PACKAGE_SOURCE_COPY svn export --force)
+  if( OPT_DOUBLE_PRECISION )
+    set(CPACK_PACKAGE_DESCRIPTION_SUMMARY "${CPACK_PACKAGE_DESCRIPTION_SUMMARY} using double precision")
+  else()

=== dom/CMakeLists.txt ===
set(COLLADA_INTERNAL_INCLUDE ${CMAKE_CURRENT_SOURCE_DIR}/include)
include_directories(${COLLADA_INTERNAL_INCLUDE})
set(COLLADA_LIBS minizip ${libpcrecpp_LIBRARIES} ${ZLIB_LIBRARIES} ${Boost_FILESYSTEM_LIBRARY} ${Boost_SYSTEM_LIBRARY})

file(GLOB dae_files ${CMAKE_CURRENT_SOURCE_DIR}/src/dae/*.cpp)
if( LIBXML2_FOUND )
  file(GLOB libxmlplugin_files ${CMAKE_CURRENT_SOURCE_DIR}/src/modules/LIBXMLPlugin/*.cpp)
  set(COLLADA_LIBS ${COLLADA_LIBS} ${LIBXML2_LIBRARIES})
else()
  set(libxmlplugin_files)
endif()
file(GLOB stddatabase_files ${CMAKE_CURRENT_SOURCE_DIR}/src/modules/STLDatabase/*.cpp)
file(GLOB stderrplugin_files ${CMAKE_CURRENT_SOURCE_DIR}/src/modules/stdErrPlugin/*.cpp)

set(COLLADA_BASE_SOURCES ${dae_files} ${libxmlplugin_files} ${stddatabase_files} ${stderrplugin_files})
set(COLLADA_COMPILE_FLAGS "${libpcrecpp_CFLAGS_OTHERS} ${EXTRA_COMPILE_FLAGS} ${Boost_CFLAGS}")
# create dynamic libraries
set(COLLADA_COMPILE_FLAGS "${COLLADA_COMPILE_FLAGS} -DDOM_DYNAMIC -DDOM_EXPORT")

if( OPT_COLLADA15 )
  add_subdirectory(src/1.5)
  set(COLLADA_LIBS ${COLLADA_LIBS} colladadom150)
  install(DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/include/1.5 DESTINATION ${COLLADA_DOM_INCLUDE_INSTALL_DIR} COMPONENT ${COMPONENT_PREFIX}-dev  PATTERN ".svn" EXCLUDE PATTERN ".~" EXCLUDE)
endif()
if( OPT_COLLADA14 )
  add_subdirectory(src/1.4)
  set(COLLADA_LIBS ${COLLADA_LIBS} colladadom141)
  install(DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/include/1.4 DESTINATION ${COLLADA_DOM_INCLUDE_INSTALL_DIR} COMPONENT ${COMPONENT_PREFIX}-dev  PATTERN ".svn" EXCLUDE PATTERN ".~" EXCLUDE)
endif()

add_library(collada-dom SHARED ${COLLADA_BASE_SOURCES})
target_link_libraries(collada-dom ${COLLADA_LIBS})
set_target_properties(collada-dom PROPERTIES
  COMPILE_FLAGS "${COLLADA_COMPILE_FLAGS}"
  LINK_FLAGS "${libpcrecpp_LDFLAGS_OTHERS}"
  OUTPUT_NAME collada-dom${COLLADA_DOM_LIBRARY_SUFFIX}
  CLEAN_DIRECT_OUTPUT 1
  SOVERSION 0 # always have it 0 since we're including the soversion as part of the library name
  VERSION ${COLLADA_DOM_VERSION})
if( MSVC )
  install(TARGETS collada-dom EXPORT collada-dom-targets RUNTIME DESTINATION bin COMPONENT ${COMPONENT_PREFIX}-base LIBRARY DESTINATION bin COMPONENT ${COMPONENT_PREFIX}-base ARCHIVE DESTINATION lib${LIB_SUFFIX} COMPONENT ${COMPONENT_PREFIX}-base)
else()
  install(TARGETS collada-dom EXPORT collada-dom-targets DESTINATION lib${LIB_SUFFIX} COMPONENT ${COMPONENT_PREFIX}-base )
endif()

install(DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/include/dae DESTINATION ${COLLADA_DOM_INCLUDE_INSTALL_DIR} COMPONENT ${COMPONENT_PREFIX}-dev PATTERN ".svn" EXCLUDE PATTERN ".~" EXCLUDE)
install(DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/include/modules DESTINATION ${COLLADA_DOM_INCLUDE_INSTALL_DIR} COMPONENT ${COMPONENT_PREFIX}-dev  PATTERN ".svn" EXCLUDE PATTERN ".~" EXCLUDE)
install(FILES ${CMAKE_CURRENT_SOURCE_DIR}/include/dae.h ${CMAKE_CURRENT_SOURCE_DIR}/include/dom.h DESTINATION ${COLLADA_DOM_INCLUDE_INSTALL_DIR} COMPONENT ${COMPONENT_PREFIX}-dev )

if( OPT_COMPILE_TESTS )
  add_subdirectory(test)
endif()

=== debian/changelog ===
collada-dom (2.4.3+ds3-1) unstable; urgency=medium

  * Remove non-free test files from DFSG tarball 

 -- Wookey <wookey@debian.org>  Wed, 14 Oct 2015 18:34:59 +0100

collada-dom (2.4.3+ds2-1.1) unstable; urgency=low

  [ Leopold Palomo-Avellaneda ]
  * Initial release,  (Closes: #589152).
  * Using the Rosen Diankov version. It's maintained.

 -- Wookey <wookey@debian.org>  Tue, 13 Oct 2015 04:41:37 +0100

=== debian/control ===
Source: collada-dom
Priority: optional
Section: Libs
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Jochen Sprickerhof <debian@jochen.sprickerhof.de>,
           Leopold Palomo-Avellaneda <leo@alaxarxa.net>,
	   Rosen Diankov <rosen.diankov@gmail.com>,
	   Wookey <wookey@debian.org>
Build-Depends: debhelper (>= 9), quilt, cmake, libxml2-dev, 
 libboost-dev, zlib1g-dev, libboost-filesystem-dev, libboost-system-dev, 
 libpcre3-dev, pkg-config, libminizip-dev
Standards-Version: 3.9.6
Homepage: https://github.com/rdiankov/collada-dom
Vcs-Git: git://anonscm.debian.org/debian-science/packages/collada-dom.git
Vcs-Browser: http://anonscm.debian.org/cgit/debian-science/packages/collada-dom.git

Package: libcollada-dom2.4-dp0
Architecture: any
Section: libs
Depends: ${shlibs:Depends}, ${misc:Depends}
Suggests: libbullet2
Description: collada-dom 2.4.0  - COLLADA using double precision
 The COLLADA Document Object Model (DOM) is an application programming
 interface (API) that provides a C++ object representation of a COLLADA XML
 instance document. 

Package: libcollada-dom2.4-dp-dev
Architecture: any
Section: libdevel
Depends: ${shlibs:Depends}, ${misc:Depends}, libcollada-dom2.4-dp0 (=${binary:Version})
Provides: libcollada-dom-dev
Suggests: libbullet2-dev
Description: collada-dom 2.4.0 C++ headers and build tools
 The COLLADA Document Object Model (DOM) is an application programming
 interface (API) that provides a C++ object representation of a COLLADA XML
 instance document. 
 .

=== debian/rules ===
#!/usr/bin/make -f

CPPFLAGS:=$(shell dpkg-buildflags --get CPPFLAGS)
CFLAGS:=$(shell dpkg-buildflags --get CFLAGS) $(CPPFLAGS)
CXXFLAGS:=$(shell dpkg-buildflags --get CXXFLAGS) $(CPPFLAGS)
LDFLAGS:=$(shell dpkg-buildflags --get LDFLAGS) -Wl,--as-needed

DEB_HOST_ARCH ?= $(shell dpkg-architecture -qDEB_HOST_ARCH)

# These don't need to be exported and if they are we'll get the flags
# duplicated in the command line.
unexport CFLAGS
unexport CXXFLAGS
unexport LDFLAGS

# SSE options
ifeq ($(DEB_HOST_ARCH),amd64)
CMAKE_ARCH_FLAGS = -DENABLE_SSE=ON -DENABLE_SSE2=ON -DENABLE_SSSE3=OFF 
else
CMAKE_ARCH_FLAGS = -DENABLE_SSE=OFF -DENABLE_SSE2=OFF -DENABLE_SSSE3=OFF 
endif

CMAKE_FLAGS = \
	-DCMAKE_INSTALL_PREFIX=/usr \
	-DCMAKE_VERBOSE_MAKEFILE=ON \
	-DCMAKE_C_FLAGS_RELEASE="$(CFLAGS)" \
	-DCMAKE_CXX_FLAGS_RELEASE="$(CXXFLAGS)" \
	-DCMAKE_SHARED_LINKER_FLAGS_RELEASE="$(LDFLAGS)" \
	-DCMAKE_BUILD_TYPE=Release	\
	-DCMAKE_SKIP_RPATH=ON \
	$(CMAKE_ARCH_FLAGS) \
	-DOPT_COLLADA15=ON \
	-DOPT_COLLADA14=ON \
	-DOPT_COMPILE_VIEWER=OFF \
	-DOPT_COMPILE_FX=OFF \
	-DOPT_COMPILE_RT=OFF \
	-DOPT_BUILD_PACKAGES=OFF \
	-DOPT_BUILD_PACKAGE_DEFAULT=OFF \
	-DOPT_DOUBLE_PRECISION=ON

%:
	dh $@ --with quilt --buildsystem=cmake

override_dh_clean:
	dh_clean -O--buildsystem=cmake

override_dh_auto_configure:
	dh_auto_configure -- $(CMAKE_FLAGS) $(CMAKE_ARCH_FLAGS)

override_dh_install:
	dh_install -O--buildsystem=cmake --list-missing

## collada-dom 2.4.4%2Bds1

=== debian/changelog ===
collada-dom (2.4.4+ds1-1) unstable; urgency=medium

  * New upstream version.
  * Add liburiparser-dev.
  * Increase debhelper compat to 9
  * Added Wookey Copyright to the debian dir
  * Added parallel build
  * Fixed Lintian warnings in copyright file

 -- Leopold Palomo-Avellaneda <leo@alaxarxa.net>  Tue, 17 Nov 2015 00:24:09 +0100

## collada-dom 2.4.4+ds1

=== CMakeLists.txt ===
--- 
+++ 
@@ -5,7 +5,7 @@
 # Define here the needed parameters
 set (COLLADA_DOM_VERSION_MAJOR 2)
 set (COLLADA_DOM_VERSION_MINOR 4)
-set (COLLADA_DOM_VERSION_PATCH 3)
+set (COLLADA_DOM_VERSION_PATCH 4)
 set (COLLADA_DOM_VERSION ${COLLADA_DOM_VERSION_MAJOR}.${COLLADA_DOM_VERSION_MINOR}.${COLLADA_DOM_VERSION_PATCH})
 set (COLLADA_DOM_SOVERSION ${COLLADA_DOM_VERSION_MAJOR}.${COLLADA_DOM_VERSION_MINOR})
 
@@ -46,6 +46,7 @@
 option(OPT_BUILD_PACKAGES "Set to ON to generate CPack configuration files and packaging targets" OFF)
 option(OPT_BUILD_PACKAGE_DEFAULT "Set to ON to generate a default openrave package that creates symlinks" ON)
 option(OPT_DOUBLE_PRECISION "Use double precision for everything (daeFloat included)" ON)
+#option(OPT_USE_PCRECPP "Use pcrecpp library to find basename and parse uri, otherwise use parseruri and basename function" OFF)
 
 set(COLLADA_DOM_EXTERNAL_FLAGS)
 if( OPT_COLLADA14 )
@@ -226,25 +227,32 @@
   set(MINIZIP_INCLUDE_DIR ${CMAKE_CURRENT_SOURCE_DIR}/dom/external-libs/minizip-1.1 ${ZLIB_INCLUDE_DIR})
 endif()
 
-pkg_check_modules(libpcrecpp libpcrecpp)
-if( libpcrecpp_FOUND )
-  set(CMAKE_REQUIRED_INCLUDES ${libpcrecpp_INCLUDE_DIRS})
-  check_include_file_cxx(pcrecpp.h HAVE_PCRECPP_H)
-  set(CMAKE_REQUIRED_INCLUDES)
-  if( NOT HAVE_PCRECPP_H )
-    set(libpcrecpp_FOUND 0)
-  endif()
-endif()
-
-if( NOT libpcrecpp_FOUND )
-  message(STATUS "System pcre not found, using local from sources")
-  # include the local pcre
-  add_subdirectory(dom/external-libs/pcre-8.02)
-  set(libpcrecpp_INCLUDE_DIRS ${CMAKE_CURRENT_SOURCE_DIR}/dom/external-libs/pcre-8.02)
-  set(libpcrecpp_LIBRARY_DIRS)
-  set(libpcrecpp_LIBRARIES pcrecpp_local)
-  set(libpcrecpp_CFLAGS_OTHERS "-DPCRE_STATIC")
-  set(libpcrecpp_LDFLAGS_OTHERS)
+pkg_check_modules(liburiparser liburiparser)
+
+if(liburiparser_FOUND)
+  set(liburiparser_CFLAGS_OTHERS "-DUSE_URIPARSER")
+else()
+  # try using pcrecpp
+  pkg_check_modules(libpcrecpp libpcrecpp)
+  if( libpcrecpp_FOUND )
+    set(CMAKE_REQUIRED_INCLUDES ${libpcrecpp_INCLUDE_DIRS})
+    check_include_file_cxx(pcrecpp.h HAVE_PCRECPP_H)
+    set(CMAKE_REQUIRED_INCLUDES)
+    if( NOT HAVE_PCRECPP_H )
+      set(libpcrecpp_FOUND 0)
+    endif()
+  endif()
+
+  if( NOT libpcrecpp_FOUND )
+    message(STATUS "System pcre not found, using local from sources")
+    # include the local pcre
+    add_subdirectory(dom/external-libs/pcre-8.02)
+    set(libpcrecpp_INCLUDE_DIRS ${CMAKE_CURRENT_SOURCE_DIR}/dom/external-libs/pcre-8.02)
+    set(libpcrecpp_LIBRARY_DIRS)
+    set(libpcrecpp_LIBRARIES pcrecpp_local)
+    set(libpcrecpp_CFLAGS_OTHERS "-DPCRE_STATIC")
+    set(libpcrecpp_LDFLAGS_OTHERS)
+  endif()
 endif()
 
 # declare minizip/zlib before libxml2! (for some reason the precompiled libxml2 libraries have zlib.h/zconf.h)
@@ -288,9 +296,3 @@
   # Packing information
   set(CPACK_PACKAGE_NAME collada-dom${COLLADA_DOM_SOVERSION})
   set(CPACK_PACKAGE_CONTACT "" CACHE STRING "Package maintainer and PGP signer.")
-  set(CPACK_PACKAGE_VENDOR "http://sourceforge.net/projects/collada-dom")
-  set(CPACK_PACKAGE_DISPLAY_NAME "collada-dom ${COLLADA_DOM_VERSION}")
-  set(CPACK_PACKAGE_DESCRIPTION_SUMMARY " - COLLADA")
-  if( OPT_DOUBLE_PRECISION )
-    set(CPACK_PACKAGE_DESCRIPTION_SUMMARY "${CPACK_PACKAGE_DESCRIPTION_SUMMARY} using double precision")
-  else()

=== dom/src/1.4/CMakeLists.txt ===
file(GLOB dom_files ${CMAKE_CURRENT_SOURCE_DIR}/dom/*.cpp)
add_library(colladadom141 STATIC ${dom_files})
set_target_properties(colladadom141 PROPERTIES COMPILE_FLAGS "${COLLADA_COMPILE_FLAGS}" LINK_FLAGS "${libpcrecpp_LDFLAGS_OTHERS}")

=== dom/test/1.4/CMakeLists.txt ===
include_directories(${COLLADA_INTERNAL_INCLUDE}/1.4)
add_executable(domTest141 domTest.cpp export.cpp integrationExample.cpp)
set_target_properties(domTest141 PROPERTIES COMPILE_FLAGS "${COLLADA_DOM_EXTERNAL_FLAGS} -DCOLLADA_DOM_USING_141")
target_link_libraries(domTest141 collada-dom)

# have to create a symlink to the data or otherwise tests will not be able to find files
execute_process(COMMAND ${CMAKE_COMMAND} -E create_symlink ${CMAKE_CURRENT_SOURCE_DIR}/data ${CMAKE_CURRENT_BINARY_DIR}/data)

=== debian/changelog ===
collada-dom (2.4.4+ds1-2build5) focal; urgency=medium

  * No change rebuild against new boost1.71 ABI

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Mon, 03 Feb 2020 20:07:05 +0000

collada-dom (2.4.4+ds1-2build4) cosmic; urgency=medium

  * No-change rebuild for boost soname change.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 17 Jul 2018 12:54:07 +0000

collada-dom (2.4.4+ds1-2build3) bionic; urgency=medium

  * No-change rebuild for boost soname change.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 26 Oct 2017 17:11:21 +0000

collada-dom (2.4.4+ds1-2build2) zesty; urgency=high

  * No change rebuild against boost1.62.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Tue, 01 Nov 2016 16:13:04 +0000

collada-dom (2.4.4+ds1-2build1) yakkety; urgency=medium

  * No-change rebuild for boost soname change.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 04 Aug 2016 08:13:49 +0000

collada-dom (2.4.4+ds1-2) unstable; urgency=medium

  * Add patch to solve return type. (Closes: #811658)
  * Update patches
  * Reformat patch to follow gbp-pq. Wookey authorship
  * Update VCS-* fields to avoid uses-insecure-uri
  * Bumped Standards-Version to 3.9.8. No changes

 -- Leopold Palomo-Avellaneda <leo@alaxarxa.net>  Thu, 30 Jun 2016 08:14:19 +0200

=== debian/control ===
--- 
+++ 
@@ -1,22 +1,22 @@
 Source: collada-dom
 Priority: optional
-Section: Libs
-Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
+Section: science
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
 Uploaders: Jochen Sprickerhof <debian@jochen.sprickerhof.de>,
            Leopold Palomo-Avellaneda <leo@alaxarxa.net>,
 	   Rosen Diankov <rosen.diankov@gmail.com>,
 	   Wookey <wookey@debian.org>
 Build-Depends: debhelper (>= 9), quilt, cmake, libxml2-dev, 
  libboost-dev, zlib1g-dev, libboost-filesystem-dev, libboost-system-dev, 
- libpcre3-dev, pkg-config, libminizip-dev
-Standards-Version: 3.9.6
+ libpcre3-dev, pkg-config, libminizip-dev, liburiparser-dev
+Standards-Version: 3.9.8
 Homepage: https://github.com/rdiankov/collada-dom
-Vcs-Git: git://anonscm.debian.org/debian-science/packages/collada-dom.git
-Vcs-Browser: http://anonscm.debian.org/cgit/debian-science/packages/collada-dom.git
+Vcs-Git: https://anonscm.debian.org/git/debian-science/packages/collada-dom.git
+Vcs-Browser: https://anonscm.debian.org/git/debian-science/packages/collada-dom.git
 
 Package: libcollada-dom2.4-dp0
 Architecture: any
-Section: libs
 Depends: ${shlibs:Depends}, ${misc:Depends}
 Suggests: libbullet2
 Description: collada-dom 2.4.0  - COLLADA using double precision

=== debian/watch ===
# Compulsory line, this is a version 3 file
version=3

# Uncomment to find new files on sourceforge, for devscripts >= 2.9
# Old upstream version. We change to github from Rosen Diankov
#opts=uversionmangle=s/$/+dfsg/ \
# http://sf.net/collada-dom/collada-dom-(.*)\.tar\.gz
# https://github.com/rdiankov/collada-dom/releases (?:.*/)?v?(\d[\d\.]*)\.tar\.gz

#opts=filenamemangle=s/.+\/v?(\d\S*)\.tar\.gz/collada-dom-$1\.tar\.gz/ repacksuffix=+ds1 \
# https://github.com/rdiankov/collada-dom/releases .*/v?(\d\S*)\.tar\.gz
# For GitHub projects you can use the tags or releases page.  Since the
# archive
# URLs use only the version as the name, it is recommended to use a
# filenamemangle to adjust the name of the downloaded file:
#opts="filenamemangle=s/(?:.*)?v?(\d[\d\.]*)\.tar\.gz/collada-dom-$1.tar.gz/" \
# https://github.com/rdiankov/collada-dom/releases ?:.*/)?v?(\d[\d\.]*)\.tar\.gz
opts=filenamemangle=s/.+\/v?(\d\S*)\.tar\.gz/collada-dom-$1\.tar\.gz/,dversionmangle=s/\+ds1\d?$//,repacksuffix=+ds1 \
  https://github.com/rdiankov/collada-dom/releases .*/v?(\d\S*)\.tar\.gz

## collada-dom 2.5.0%2Bds1

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

CMAKE_FLAGS = \
	-DCMAKE_POLICY_MINIMUM_VERSION=3.10 \
	-DCMAKE_SHARED_LINKER_FLAGS_RELEASE="$(LDFLAGS)" \
	-DLIB_SUFFIX=/$(DEB_HOST_MULTIARCH) \
	-DCMAKE_SKIP_RPATH=ON \
	-DOPT_COLLADA15=ON \
	-DOPT_COLLADA14=ON \
	-DOPT_COMPILE_VIEWER=OFF \
	-DOPT_COMPILE_FX=OFF \
	-DOPT_COMPILE_RT=OFF \
	-DOPT_BUILD_PACKAGES=OFF \
	-DOPT_BUILD_PACKAGE_DEFAULT=OFF \
	-DOPT_DOUBLE_PRECISION=ON

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- $(CMAKE_FLAGS)
